<template>
    <div    class="field-upload-ois"
            @click.stop="$refs.file.click()"
            @dragover.prevent.stop
            @dragenter.prevent.stop
            @drop.stop.prevent="dropFile"
    >
        <a class="field-upload-ois__link" @click.stop="$router.push('/ois')"><span>Мои оис</span></a>
        <div class="field-upload-ois__content">
            <div class="field-upload-ois__status">
                <div :class="['field-upload-ois__status-icon', {
                        'field-upload-ois__status-icon--error': error || httpError,
                        'field-upload-ois__status-icon--success': httpSuccess,
                        'field-upload-ois__status-icon--loading': httpProgress && !httpSuccess && !error && !httpError
                    }]"
                >
                    <div v-if="httpProgress && !httpSuccess && !error && !httpError" class="ring loader-large center-center">
                        <div class="ring loader-middle center-center">
                            <div class="ring loader-small"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="field-upload-ois__text">
                <div v-if="error || httpError">
                    <div class="field-upload-ois__error">{{ error || httpError }}</div>
                    <div class="field-upload-ois__load-orher">Загрузить другой файл</div>
                </div>
                <div v-else-if="httpProgress && !httpSuccess">
                    <div class="field-upload-ois--uppercase">Загружено {{ httpProgress }}%</div>
                </div>
                <div v-else-if="file">
                    <div>{{ file.name }}</div>
                    <div class="field-upload-ois__load-orher">Загрузить другой файл</div>
                </div>
                <div v-else>
                    <div class="field-upload-ois__text-default">
                        <span class="field-upload-ois__select-file field-upload-ois--uppercase">ВЫБЕРИТЕ ФАЙЛ</span>
                        <span>или</span>
                        <span class="field-upload-ois__drop-here field-upload-ois--uppercase">ПЕРЕТАЩИТЕ ЕГО СЮДА</span>
                    </div>
                    <div class="field-upload-ois__types">MP3 (не менее 320 kbps), WAV, AIFF или OGG до 200 МБ</div>
                </div>
            </div>
            <input  ref="file"
                    type="file"
                    class="field-upload-ois__input"
                    @change="selectFile"
            >
        </div>
        <div v-show="!error && !httpError" :style="{'width': `${httpProgress}%`}" class="field-upload-ois__status-bar"></div>
    </div>
</template>

<script>
export default {
    name: 'base-field-upload-ois',
    props: {
        value: [Object, File],
        maxSize: {
            type: Number,
            default: 200000000
        },
        httpProgress: {
            type: Number,
            required: true
        },
        httpSuccess: {
            type: Boolean,
            required: true,
            default: false
        },
        httpError: {
            type: String,
            default: ''
        }
    },
    data() {
        return {
            file: null,
            loaded: 0,
            loading: false,
            availableTypes: [
                'mp3',
                'wav',
                'aiff',
                'ogg'
            ],
            error: ''
        };
    },
    watch: {
        value(val) {
            if (val === null && this.file) {
                this.setDefaultValues();
                this.$refs.file.value = '';
            }
        }
    },
    methods: {
        selectFile(e) {
            const [file] = e.target.files;
            this.upload(file);
        },
        dropFile(e) {
            const [file] = e.dataTransfer.files;
            this.upload(file);
        },
        upload(file) {
            this.error = '';
            if (file && this.checkValideFile(file)) {
                this.setDefaultValues();
                this.setProperyFile(file);
                this.$emit('input', file);
                return;
            }
            this.$emit('input', null);
            this.setDefaultValues();
        },
        setProperyFile(file) {
            this.file = Object.assign({
                name: file.name,
                size: file.size,
                type: file.type
            });
        },
        setDefaultValues() {
            this.file = null;
            this.loaded = 0;
        },
        checkValideFile(file) {
            const [type, expansion] = file.type.split('/');
            const size = file.size;

            if (!type || !expansion || !this.availableTypes.includes(expansion) || type !== 'audio') {
                this.error = 'Неподдерживаемый формат файла';
                return false;
            }

            if (size > this.maxSize) {
                this.error = 'Некорретный вес файла.';
                return false;
            }

            return true;
        }
    }
};
</script>

<style lang="sass">
@import "~assets/blocks/fields/field-upload-ois/index"
</style>
